#!/bin/sh
# ============================================================================
#
# This file is part of the 'PlexMediaServer' package
# 
# This program is free software; you can redistribute it and/or modify it 
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# Author: Mijzelf <Mijzelf@live.com>
#
# ============================================================================
PKG_NAME="PlexMediaServer"
THIS_SCRIPT="PlexMediaServer"
PKG_FIRMWARE=4

############################################################
## Check if we are in upgradig mode. From the point of view of the package
## an upgrade is a uninstall followed by a install. So if you want to preserve
## something over an upgrade, you have to detect it somehow
##
## Function sets PKG_UPGRADE > 0 when upgrading, 
## and PKG_UPGRADE=0 when not
############################################################
IsUpgrading()
{
	PKG_UPGRADING=0
	local dir=
	for dir in "/usr/local/zy-pkgs/" "/i-data/.system/zy-pkgs/"
	do
		local logfile=${dir}tmp/zypkg.log
		[ ! -f ${logfile} ] && continue

		local lastupdate=` grep "Upgrade Mode" ${logfile} | tail -n 1 | grep "\[${PKG_NAME}\]" | awk -v OFS=' ' '{print $1, $2}' `

	        [ "${lastupdate}" = "" ] && return 1

		local since1970=` TZ=GMT date -d "${lastupdate}" +%s `
		local now=`date +%s `
		local ago=""
		let ago=now-since1970
		[ $ago -eq 0 ] && ago=1
		[ 300 -gt $ago ] && PKG_UPGRADING=$ago && return 0

		return 1
	done

	# We shouldn't be here
	return 1
}

#############################################################
## Dummy logcode
#############################################################
Log() 
{
	return
}

######################################
## Find the IP address of the box
FrameworkGetIPAddress()
{
	# Detect interfaces
	local interfaces=` ifconfig | grep -e "^egiga" -e "^bond" -e "^eth" | cut -d ' ' -f 1 `

	# And find the IP (v4) address
	for interface in $interfaces
	do
		local address=` ifconfig ${interface} | grep "inet addr" | tr -s ' ' `
		if [ "${address}" != "" ] ; then
			echo ${address} | cut -d ' ' -f 2 | cut -d ':' -f 2
			return
		fi
	done
	hostname # What else?
}

#####################################
## Echo the URL of the package
FrameworkGetLink()
{
	# Do we have a webinterface at all?
	[ ! -d ${PKG_ROOT}/gui/${PKG_NAME}/ ] && exit 0

	local address=` FrameworkGetIPAddress `

	# Seach for configured ports
	local ports=
	for directory in /etc/pkg_service_conf /etc/service_conf
	do
		[ ! -d ${directory} ] && continue

		ports=` grep "^Listen" ${directory}/httpd_zld*.conf | awk '{ print $2 }' `
		ports="$ports ` grep "^<VirtualHost" ${directory}/httpd_zld*.conf | cut -d ':' -f 2 | cut -d '>' -f 1 `"
		ports=` echo $ports | tr -s ' ' | tr ' ' '\n' | sort | uniq | grep -v 8082 `
		break
	done

	for port in $ports
	do
		# Find out if it's https:
		protocol=http
		defaultport=80
		grep -i "^<VirtualHost.*${port}" -A 50 ${directory}/httpd_zld*.conf >/tmp/.$$.${PKG_NAME}

		while read line
		do
			if echo $line | grep -i "^</VirtualHost" >/dev/null
			then
				break
			fi

			if echo $line | grep -i "SSLEngine *On" >/dev/null
			then
				protocol=https
				defaultport=443
			fi
		done </tmp/.$$.${PKG_NAME}
		rm /tmp/.$$.${PKG_NAME}

		[ ${defaultport} -eq 443 ] && continue # Package manager crashes on https :$


		[ $port -eq $defaultport ] && port="" || port=":${port}"

		local url="${protocol}://${address}${port}/pkg/${PKG_NAME}/"

		echo  $url
		# We can only output a single url
		return
	done
}

######################################
## Status get and set
FrameworkStatus()
{
	local pkg_config_file="${PKG_ROOT}/config/${PKG_NAME}/config"
	if [ "get" = "$1" ] ; then
		if [ ! -f ${pkg_config_file} ] ; then
			FrameworkStatus set Disabled
		fi
		cat ${pkg_config_file}
		return
	elif [ "set" = "$1" ] ; then
		mkdir -p ` dirname ${pkg_config_file} `
		
		echo $2 >${pkg_config_file}
	fi
}

################################################
## Run or stop the package
FrameworkRun()
{
	if [ $1 -eq 1 ] ; then
		# Startup
		STATUS=` FrameworkStatus get `
		[ "$STATUS" != "Enabled" ] && return	# We're not enabled

		# Do we have a webinterface?
		if [ -d ${PKG_ROOT}/gui/${PKG_NAME}/ ] ; then
			# Aparently 
			for httpdconf in /etc/pkg_service_conf/httpd_package2.conf
			do
				[ ! -f ${httpdconf} ] && continue
				
				local service_conf=` dirname $httpdconf `

				echo Alias /pkg/${PKG_NAME}/ ${PKG_ROOT}/gui/${PKG_NAME}/ >${service_conf}/${PKG_NAME}.conf
				if ! grep ${PKG_NAME}.conf ${httpdconf} >/dev/null
				then
					sed -i "1iInclude ${service_conf}/${PKG_NAME}.conf" ${httpdconf}
				fi

				# Let the package manager restart the server
				touch /tmp/restart_httpd
				break
			done

		fi

		[ ! -f /lib/ld-linux.so.3 -a -f /lib/ld-linux-armhf.so.3 ] && ln -s ld-linux-armhf.so.3 /lib/ld-linux.so.3 

		Startup
		return
	fi

	Shutdown
	
	for httpdconf in /etc/pkg_service_conf/httpd_package2.conf
	do
		[ ! -f ${httpdconf} ] && continue
		grep -v ${PKG_NAME}.conf ${httpdconf} >/tmp/$$.httpd.conf
		mv /tmp/$$.httpd.conf ${httpdconf}
		touch /tmp/restart_httpd
	break
	done

}

FrameworkVersion()
{
	local controlfile=${PKG_ROOT}/zypkg_conf/info/${PKG_NAME}.control
	local version=$( grep "^Version:" ${controlfile} | awk -F"zypkg" '{print $2}' )
	exit $version
}

FrameworkParseParams()
{
	case $1 in
		getlink)
			FrameworkGetLink
			;;
		status)
			FrameworkStatus get
			;;
		enable)
			FrameworkStatus set Enabled 
			FrameworkRun 1
			;;
		disable)
			FrameworkRun 0
			FrameworkStatus set Disabled 
			;;
		startup)
			FrameworkRun 1
			;;
		shutdown)
			FrameworkRun 0
			;;
		version)
			FrameworkVersion
			;;
	esac
}

Log

PKG_ROOT="/usr/local/zy-pkgs"


PKG_ROOT="/usr/local/zy-pkgs"

. ${PKG_ROOT}/gui/PlexMediaServer/environment.sh

StartPlexAsNobody()
{
	export PLEX_USER=$( whoami )

	#Provides:Plex Media Server start
	export PLEX_MEDIA_SERVER_HOME

	# Set the directory, where libraries should be searched for first
	export LD_LIBRARY_PATH="${PLEX_MEDIA_SERVER_HOME}"

	# Set the number of plugins, that can run at the same time 
	export PLEX_MEDIA_SERVER_MAX_PLUGIN_PROCS=6

	# Set directory, where the PMS should store the transcodes 
	export TMPDIR=${PLEX_MEDIA_SERVER_TMPDIR}
	export PLEX_MEDIA_SERVER_TMPDIR
	
	# Set the main directory for Plex (metadata, settings, databases, logs and etc) 
	export PLEX_MEDIA_SERVER_APPLICATION_SUPPORT_DIR

	# Set the maximum stack size value.
	[ "" != "$PLEX_MEDIA_SERVER_MAX_STACK_SIZE" ] && ulimit -s $PLEX_MEDIA_SERVER_MAX_STACK_SIZE && export PLEX_MEDIA_SERVER_MAX_STACK_SIZE
	# PLEX_MEDIA_SERVER_MAX_STACK_SIZE=10000

	[ "" != "$PLEX_MEDIA_SERVER_MAX_LOCK_MEM" ] && ulimit -l $PLEX_MEDIA_SERVER_MAX_LOCK_MEM && export PLEX_MEDIA_SERVER_MAX_LOCK_MEM
	# PLEX_MEDIA_SERVER_MAX_LOCK_MEM=3000
 
	[ "" != "$PLEX_MEDIA_SERVER_MAX_OPEN_FILES" ] && ulimit -n $PLEX_MEDIA_SERVER_MAX_OPEN_FILES && export PLEX_MEDIA_SERVER_MAX_OPEN_FILES
	# PLEX_MEDIA_SERVER_MAX_OPEN_FILES=4096

	local logdir="${PLEX_MEDIA_SERVER_APPLICATION_SUPPORT_DIR}/Plex Media Server/Logs"
	mkdir -p "${logdir}"

#	set >"${logdir}/Start.log"

#	mkdir -p "${logdir}/strace.$$"

	#Run PMS server
	echo -n "Starting Plex Media Server..."

#	strace -o "${logdir}/strace.$$/log" -ff 


	${PLEX_MEDIA_SERVER_HOME}/Plex\ Media\ Server </dev/null >"${logdir}/Start.log" 2>&1 &
	

	local PID_FILE="${PLEX_MEDIA_SERVER_APPLICATION_SUPPORT_DIR}/Plex Media Server/plexmediaserver.pid"
	for _wait in 1 2 3 4 5 6 7 8 9 0
	do
	    if [ -f "${PID_FILE}" ] ; then
		echo "done"
		return
	    fi
	    sleep 2
	done
	echo "failed?"
	cat "${logdir}/Start.log"
}

Startup()
{
	local plexroot=${PKG_ROOT}/share/PlexMediaServer 
	mkdir -p "${plexroot}"
	chown -R nobody:nobody "${plexroot}"

	for dir in ${PLEX_MEDIA_SERVER_HOME} ${PLEX_MEDIA_SERVER_TMPDIR} ${PLEX_MEDIA_SERVER_APPLICATION_SUPPORT_DIR} ${PLEX_MEDIA_SERVER_ROOT}
	do
	    mkdir -p ${dir}
	    chown -R nobody:nobody ${dir}
	done

	# For NAS500    
	[ ! -f /lib/ld-linux.so.3 -a -f /lib/ld-linux-armhf.so.3 ] && ln -s ld-linux-armhf.so.3 /lib/ld-linux.so.3 
	
	[ ! -x ${PLEX_MEDIA_SERVER_HOME}/Plex\ Media\ Server ] && echo -e "\n\tPlex Media server is not yet installed" && return 0

	su nobody -s /bin/sh -c "/bin/sh $0 pms_start"
	return 0
}

IsPlexRunning ()
{
	# Pidfile. Do not change. It's hardcoded relative to PLEX_MEDIA_SERVER_APPLICATION_SUPPORT_DIR
	local PID_FILE="${PLEX_MEDIA_SERVER_APPLICATION_SUPPORT_DIR}/Plex Media Server/plexmediaserver.pid"

	if [ -f "$PID_FILE" ] ; then
		if cat /proc/` cat "$PID_FILE" `/cmdline 2>/dev/null | grep Plex >/dev/null 2>&1
		then
			return 0
		fi
		rm "$PID_FILE"
	fi
	
	return 1
}

StopPlex ()
{
	if IsPlexRunning
	then
		local PID_FILE=${PLEX_MEDIA_SERVER_APPLICATION_SUPPORT_DIR}/Plex\ Media\ Server/plexmediaserver.pid

		echo -n "Stopping Plex Media Server..."

		kill -15 ` cat "${PID_FILE}" `
		[ $? -ne 0 ] && echo "failed" && return

	        for _wait in 1 2 3 4 5 6 7 8 9 0
	        do
			if [ ! -f "${PID_FILE}" ] ; then
			    echo "done"
			    return
			fi
			sleep 2
		done
		echo "stopping failed?"
		return
	else
		echo "It seems that Plex Media Server is not running (no process found)..."
	fi
}

Shutdown()
{
    StopPlex
}


case $1 in 
	pms_start)
		StartPlexAsNobody
		exit $?
		;;
	pms_stop)
		StopPlex
		exit $?
		;;
	pms_status)
		IsPlexRunning
		[ $? -eq 0 ] && echo "running" && exit 0
		[ -x ${PLEX_MEDIA_SERVER_HOME}/Plex\ Media\ Server ] && echo "installed" && exit 0
		echo "not installed"
		exit 0
		;;
	disable)
		[ -f "${PLEX_MEDIA_SERVER_APPLICATION_SUPPORT_DIR}/skip_page" ] && rm "${PLEX_MEDIA_SERVER_APPLICATION_SUPPORT_DIR}/skip_page"
		;;
esac

FrameworkParseParams "$@"

exit 0
